# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudIot.V1.Model.DeviceState do
  @moduledoc """
  The device state, as reported by the device.

  ## Attributes

  *   `binaryData` (*type:* `String.t`, *default:* `nil`) - The device state data.
  *   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - [Output only] The time at which this state version was updated in Cloud IoT Core.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :binaryData => String.t(),
          :updateTime => DateTime.t()
        }

  field(:binaryData)
  field(:updateTime, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.CloudIot.V1.Model.DeviceState do
  def decode(value, options) do
    GoogleApi.CloudIot.V1.Model.DeviceState.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudIot.V1.Model.DeviceState do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
