# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudIot.V1.Model.RegistryCredential do
  @moduledoc """
  A server-stored registry credential used to validate device credentials.

  ## Attributes

  *   `publicKeyCertificate` (*type:* `GoogleApi.CloudIot.V1.Model.PublicKeyCertificate.t`, *default:* `nil`) - A public key certificate used to verify the device credentials.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :publicKeyCertificate => GoogleApi.CloudIot.V1.Model.PublicKeyCertificate.t()
        }

  field(:publicKeyCertificate, as: GoogleApi.CloudIot.V1.Model.PublicKeyCertificate)
end

defimpl Poison.Decoder, for: GoogleApi.CloudIot.V1.Model.RegistryCredential do
  def decode(value, options) do
    GoogleApi.CloudIot.V1.Model.RegistryCredential.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudIot.V1.Model.RegistryCredential do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
