# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudIot.V1.Model.X509CertificateDetails do
  @moduledoc """
  Details of an X.509 certificate. For informational purposes only.

  ## Attributes

  *   `expiryTime` (*type:* `DateTime.t`, *default:* `nil`) - The time the certificate becomes invalid.
  *   `issuer` (*type:* `String.t`, *default:* `nil`) - The entity that signed the certificate.
  *   `publicKeyType` (*type:* `String.t`, *default:* `nil`) - The type of public key in the certificate.
  *   `signatureAlgorithm` (*type:* `String.t`, *default:* `nil`) - The algorithm used to sign the certificate.
  *   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The time the certificate becomes valid.
  *   `subject` (*type:* `String.t`, *default:* `nil`) - The entity the certificate and public key belong to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :expiryTime => DateTime.t(),
          :issuer => String.t(),
          :publicKeyType => String.t(),
          :signatureAlgorithm => String.t(),
          :startTime => DateTime.t(),
          :subject => String.t()
        }

  field(:expiryTime, as: DateTime)
  field(:issuer)
  field(:publicKeyType)
  field(:signatureAlgorithm)
  field(:startTime, as: DateTime)
  field(:subject)
end

defimpl Poison.Decoder, for: GoogleApi.CloudIot.V1.Model.X509CertificateDetails do
  def decode(value, options) do
    GoogleApi.CloudIot.V1.Model.X509CertificateDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudIot.V1.Model.X509CertificateDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
